package com.anecdote.ideaplugins.changesbar;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Copyright 2006 Nathan Brown
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
public class ChangesBarConfigurationForm
{
  private JCheckBox _addCommentEditorToCheckBox;
  private JPanel _settingsPanel;
  private JCheckBox _monitorChangelistsForConflictCheckBox;
  private JCheckBox _displayPopupWhenConflictCheckBox;
  private JLabel _versionLabel;
  private JLabel _titleLabel;
  private JPanel _root;
  private JLabel _copyrightLabel;
  private JLabel _emailLabel;

  ChangesBarConfigurationForm()
  {
    _monitorChangelistsForConflictCheckBox.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        updateForm();
      }
    });
    _versionLabel.setText("v " + ChangesBar.VERSION);
  }

  private void updateForm()
  {
    _displayPopupWhenConflictCheckBox.setEnabled(_monitorChangelistsForConflictCheckBox.isSelected());
  }

  void setData(ChangesBarApplicationComponent data)
  {
    _addCommentEditorToCheckBox.setSelected(ChangesBarApplicationComponent.isAddCommentEditor());
    _monitorChangelistsForConflictCheckBox.setSelected(ChangesBarApplicationComponent.isWatchForCollisions());
    _displayPopupWhenConflictCheckBox.setSelected(ChangesBarApplicationComponent.isShowPopup());
    updateForm();
  }

  void getData(ChangesBarApplicationComponent data)
  {
    ChangesBarApplicationComponent.setAddCommentEditor(_addCommentEditorToCheckBox.isSelected());
    ChangesBarApplicationComponent.setWatchForCollisions(_monitorChangelistsForConflictCheckBox.isSelected());
    ChangesBarApplicationComponent.setShowPopup(_displayPopupWhenConflictCheckBox.isSelected());
  }

  boolean isModified(ChangesBarApplicationComponent data)
  {
    if (_addCommentEditorToCheckBox.isSelected() != ChangesBarApplicationComponent.isAddCommentEditor()) {
      return true;
    }
    if (_monitorChangelistsForConflictCheckBox.isSelected() != ChangesBarApplicationComponent.isWatchForCollisions()) {
      return true;
    }
    return _displayPopupWhenConflictCheckBox.isSelected() != ChangesBarApplicationComponent.isShowPopup();
  }

  JComponent getRootComponent()
  {
    return _root;
  }
}
